<?php
/* --------------------------------------------------------------
 RegisterGXModules.php 2020-09-17
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Application\Registry\ModuleRegistry\App\CommandHandlers;

use Gambio\Admin\Application\Registry\ModuleRegistry\Services\ModuleRegistryService;
use Gambio\Core\Application\Modules\App\Commands\SearchModules;

/**
 * Class RegisterGXModules
 * @package Gambio\Admin\Application\Registry\ModuleRegistry\App\CommandHandlers
 * @codeCoverageIgnore
 */
class RegisterGXModules
{
    /**
     * @var ModuleRegistryService
     */
    private $registryService;
    
    
    /**
     * RegisterGXModules constructor.
     *
     * @param ModuleRegistryService $registryService
     */
    public function __construct(ModuleRegistryService $registryService)
    {
        $this->registryService = $registryService;
    }
    
    
    /**
     * @param SearchModules $command
     *
     * @return SearchModules
     */
    public function __invoke(SearchModules $command): SearchModules
    {
        $moduleRegistry = $this->registryService->getRegistry();
        
        foreach ($moduleRegistry->modules() as $module) {
            if (class_exists($module)) {
                $command->addModule(new $module);
            }
        }
        
        return $command;
    }
}