<?php
/* --------------------------------------------------------------
 RegisterGxModulesProvider.php 2020-09-17
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Application\Registry\ModuleRegistry\App\CommandHandlers;

use Gambio\Admin\Application\Registry\ModuleRegistry\Services\ModuleRegistryService;
use Gambio\Core\Application\Modules\App\Commands\SearchServiceProvider;

/**
 * Class RegisterGxModulesProvider
 * @package Gambio\Admin\Application\Registry\ModuleRegistry\App\CommandHandlers
 * @codeCoverageIgnore
 */
class RegisterGxModulesProvider
{
    /**
     * @var ModuleRegistryService
     */
    private $registryService;
    
    
    /**
     * RegisterGxModulesProvider constructor.
     *
     * @param ModuleRegistryService $registryService
     */
    public function __construct(ModuleRegistryService $registryService)
    {
        $this->registryService = $registryService;
    }
    
    
    /**
     *
     * @param SearchServiceProvider $command
     *
     * @return SearchServiceProvider
     */
    public function __invoke(SearchServiceProvider $command): SearchServiceProvider
    {
        $moduleRegistry = $this->registryService->getRegistry();
        foreach ($moduleRegistry->serviceProviders() as $provider) {
            $command->addServiceProvider($provider);
        }
        
        return $command;
    }
}