<?php
/* --------------------------------------------------------------
 ModuleRegistryInformation.php 2020-09-17
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Application\Registry\ModuleRegistry\Model;

/**
 * Interface ModuleRegistry
 * @package Gambio\Admin\Application\Registry\ModuleRegistry\Model
 */
interface ModuleRegistry
{
    /**
     * Returns a list of full qualified module class names.
     *
     * @return array
     */
    public function modules(): array;
    
    
    /**
     * Returns a list of full qualified service provider class names.
     *
     * @return array
     */
    public function serviceProviders(): array;
    
    
    /**
     * Returns a list autoloader paths.
     *
     * @return array
     */
    public function autoloaderPaths(): array;
}