<?php
/* --------------------------------------------------------------
 ModuleRegistry.php 2020-09-17
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Application\Registry\ModuleRegistry\Model\ValueObject;

/**
 * Class ModuleRegistry
 * @package Gambio\Admin\Application\Registry\ModuleRegistry\Model\ValueObject
 */
class ModuleRegistry implements \Gambio\Admin\Application\Registry\ModuleRegistry\Model\ModuleRegistry
{
    /**
     * @var array
     */
    private $modules;
    
    /**
     * @var array
     */
    private $serviceProvider;
    
    /**
     * @var array
     */
    private $autoloaderPaths;
    
    
    /**
     * ModuleRegistry constructor.
     *
     * @param array $modules
     * @param array $serviceProvider
     * @param array $autoloaderPaths
     */
    public function __construct(array $modules, array $serviceProvider, array $autoloaderPaths)
    {
        $this->modules         = $modules;
        $this->serviceProvider = $serviceProvider;
        $this->autoloaderPaths = $autoloaderPaths;
    }
    
    
    /**
     * @inheritDoc
     */
    public function modules(): array
    {
        return $this->modules;
    }
    
    
    /**
     * @inheritDoc
     */
    public function serviceProviders(): array
    {
        return $this->serviceProvider;
    }
    
    
    /**
     * @inheritDoc
     */
    public function autoloaderPaths(): array
    {
        return $this->autoloaderPaths;
    }
}