<?php
/* --------------------------------------------------------------
 ProviderRegistry.php 2020-09-18
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Application\Registry\ProviderRegistry\Model\ValueObject;

use Gambio\Admin\Application\Registry\ProviderRegistry\Model\ProviderRegistry as Registry;

/**
 * Class ProviderRegistry
 * @package Gambio\Admin\Application\Registry\ProviderRegistry\Model\ValueObject
 */
class ProviderRegistry implements Registry
{
    /**
     * @var array
     */
    private $serviceProviders;
    
    
    /**
     * ProviderRegistry constructor.
     *
     * @param array $serviceProviders
     */
    public function __construct(array $serviceProviders)
    {
        $this->serviceProviders = $serviceProviders;
    }
    
    
    /**
     * @inheritDoc
     */
    public function serviceProviders(): array
    {
        return $this->serviceProviders;
    }
}