<?php
/* --------------------------------------------------------------
 ConnectPageHandler.php 2020-07-29
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Layout\Menu\CommandHandlers;

use Gambio\Admin\Layout\Menu\Commands\ConnectPage;
use Gambio\Admin\Layout\Menu\Models\ConnectedPage;

/**
 * Class ConnectPageHandler
 * @package Gambio\Admin\Layout\Menu\CommandHandlers
 */
class ConnectPageHandler
{
    /**
     * @var ConnectedPage
     */
    private $connectedPage;
    
    
    /**
     * ConnectPagesHandler constructor.
     *
     * @param ConnectedPage $connectedPage
     */
    public function __construct(ConnectedPage $connectedPage)
    {
        $this->connectedPage = $connectedPage;
    }
    
    
    /**
     * @param ConnectPage $connectPage
     *
     * @return ConnectPage
     */
    public function __invoke(ConnectPage $connectPage): ConnectPage
    {
        $this->connectedPage->connect($connectPage);
        
        return $connectPage;
    }
}