<?php
/* --------------------------------------------------------------
 ConnectedPage.php 2020-07-29
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Layout\Menu\Models;

use Gambio\Admin\Layout\Menu\Commands\ConnectPage;

/**
 * Class ConnectedPage
 * @package Gambio\Admin\Layout\Menu\Models
 *
 *          The shop system use one instance of the connected page and share the reference between a command handler
 *          and the menu service. So its possible to set a connected page before the menu processing will start.
 */
class ConnectedPage
{
    /**
     * @var string|null
     */
    private $pageUrl;
    
    
    /**
     * @param ConnectPage $page
     */
    public function connect(ConnectPage $page): void
    {
        $this->pageUrl = $page->pageUrl();
    }
    
    
    /**
     * @return string|null
     */
    public function pageUrl(): ?string
    {
        return $this->pageUrl;
    }
}