<?php
/* --------------------------------------------------------------
   routes.php 2020-08-18
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

use Gambio\Admin\Modules\Configuration\App\Actions\ConfigurationOverview;
use Gambio\Admin\Modules\Configuration\App\Actions\FetchConfigurations;
use Gambio\Admin\Modules\Configuration\App\Actions\StoreConfiguration;
use Slim\App;

return static function (App $app) {
    $app->get('/configurations', ConfigurationOverview::class);
    $app->post('/api/configurations', StoreConfiguration::class);
    $app->get('/configurations/data', FetchConfigurations::class);
};
