<?php
/* --------------------------------------------------------------
  ActionUpdateCategory.php 2021-06-09
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Modules\Dashboard\App\Actions;

use Gambio\Admin\Modules\Statistics\StatisticsServiceInterface;
use Gambio\Core\Application\Modules\Http\Response;
use Gambio\Core\Application\Modules\ModuleAction;

/**
 * Class ActionUpdateCategory
 * @package Gambio\Admin\Modules\Dashboard\App\Actions
 * @codeCoverageIgnore
 */
class ActionUpdateCategory extends ModuleAction
{
    
    /**
     * @var StatisticsServiceInterface
     */
    private $statisticsService;
    
    
    public function __construct(StatisticsServiceInterface $statisticsService)
    {
        $this->statisticsService = $statisticsService;
    }
    
    
    /**
     * @inheritDoc
     */
    protected function handle(): Response
    {
        if (isset($this->args['category']) && is_string($this->args['category'])) {
            $this->statisticsService->updateUserPreferredCategory($this->args['category']);
        }
        
        return $this->response;
    }
}