<?php
/* --------------------------------------------------------------
 ActionUpdatePeriod.php 2020-09-29
 Gambio GmbH
 http://www.gambio.de

 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Modules\Dashboard\App\Actions;

use Gambio\Admin\Modules\Statistics\StatisticsServiceInterface;
use Gambio\Core\Application\Modules\Http\Response;
use Gambio\Core\Application\Modules\ModuleAction;

/**
 * Class ActionUpdatePeriod
 * @package Gambio\Admin\Modules\Dashboard\App\Actions
 * @codeCoverageIgnore
 */
class ActionUpdatePeriod extends ModuleAction
{
    
    /**
     * @var StatisticsServiceInterface
     */
    private $statisticsService;
    
    
    public function __construct(StatisticsServiceInterface $statisticsService)
    {
        $this->statisticsService = $statisticsService;
    }
    
    
    /**
     * @inheritDoc
     */
    protected function handle(): Response
    {
        if (isset($this->args['period']) && is_string($this->args['period'])) {
            $this->statisticsService->updateUserPreferredPeriod($this->args['period']);
        }
        
        return $this->response;
    }
}