<?php
/*------------------------------------------------------------------------------
 ActionUpdateSocialMediaEmbeds.php 2020-09-21
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/
declare(strict_types=1);

namespace Gambio\Admin\Modules\Dashboard\App\Actions;

use Gambio\Admin\Modules\Dashboard\App\Data\DashboardConfigurationStorage;
use Gambio\Core\Application\Modules\Http\Response as HttpResponse;
use Gambio\Core\Application\Modules\ModuleAction;

/**
 * Class ActionUpdateSocialMediaEmbeds
 * @package Gambio\Admin\Modules\Dashboard\App\Actions
 * @codeCoverageIgnore
 */
class ActionUpdateSocialMediaEmbeds extends ModuleAction
{
    
    /**
     * @var DashboardConfigurationStorage
     */
    private $storage;
    
    
    protected function handle(): HttpResponse
    {
        if ($this->args['status'] === 'true') {
            $this->storage->enableExternalSocialMediaEmbeds();;
        } else {
            $this->storage->disableExternalSocialMediaEmbeds();
        }
        
        return $this->response;
    }
    
    
    /**
     * ActionUpdateSocialMediaEmbeds constructor.
     *
     * @param DashboardConfigurationStorage $storage
     */
    public function __construct(
        DashboardConfigurationStorage $storage
    ) {
        
        $this->storage = $storage;
    }
    
}