<?php
/*------------------------------------------------------------------------------
 ActionUpdateStep.php 2020-09-21
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/
declare(strict_types=1);

namespace Gambio\Admin\Modules\Dashboard\App\Actions;

use Gambio\Admin\Modules\SetupWizard\SetupWizardServiceInterface;
use Gambio\Core\Application\Modules\Http\Response as HttpResponse;
use Gambio\Core\Application\Modules\ModuleAction;


/**
 * Class ActionUpdateStep
 * @package Gambio\Admin\Modules\Dashboard\App\Actions
 * @codeCoverageIgnore
 */
class ActionUpdateStep extends ModuleAction
{
    
    /**
     * @var SetupWizardServiceInterface
     */
    private $setupWizardService;
    
    
    protected function handle(): HttpResponse
    {
        if ($this->args['status'] === 'true' && isset($this->args['step']) && is_string($this->args['step'])) {
            $this->setupWizardService->setStepComplete($this->args['step']);
        } else {
            $this->setupWizardService->setStepIncomplete($this->args['step']);
        }
        
        return $this->response;
    }
    
    
    /**
     * ActionUpdateStep constructor.
     *
     * @param SetupWizardServiceInterface $setupWizardService
     */
    public function __construct(
        SetupWizardServiceInterface $setupWizardService
    ) {
        $this->setupWizardService = $setupWizardService;
    }
}