<?php
/*------------------------------------------------------------------------------
 ActionUpdateVisibility.php 2020-09-21
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/
declare(strict_types=1);

namespace Gambio\Admin\Modules\Dashboard\App\Actions;

use Gambio\Admin\Modules\SetupWizard\SetupWizardServiceInterface;
use Gambio\Core\Application\Modules\Http\Response as HttpResponse;
use Gambio\Core\Application\Modules\ModuleAction;

/**
 * Class ActionUpdateVisibility
 * @package Gambio\Admin\Modules\Dashboard\App\Actions
 * @codeCoverageIgnore
 */
class ActionUpdateVisibility extends ModuleAction
{
    /**
     * @var SetupWizardServiceInterface
     */
    protected $setupWizardService;
    
    
    public function __construct(
        SetupWizardServiceInterface $setupWizardService
    ) {
        $this->setupWizardService = $setupWizardService;
    }
    
    
    protected function handle(): HttpResponse
    {
        if ($this->args['status'] === 'true') {
            $this->setupWizardService->show();;
        } else {
            $this->setupWizardService->hide();
        }
        
        return $this->response;
    }
}