<?php
/* --------------------------------------------------------------
   ParcelServiceFilterFactory.php 2020-08-28
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\ParcelService\App\Data\Filter;

/**
 * Class ParcelServiceFilterFactory
 *
 * @package Gambio\Admin\Modules\ParcelService\App\Data\Filter
 */
class ParcelServiceFilterFactory
{
    /**
     * @param int $limit
     * @param int $offset
     *
     * @return ParcelServicePagination
     */
    public function createPagination(int $limit, int $offset): ParcelServicePagination
    {
        return ParcelServicePagination::create($limit, $offset);
    }
    
    
    /**
     * @param array $filters
     *
     * @return ParcelServiceFilters
     */
    public function createFilters(array $filters): ParcelServiceFilters
    {
        return ParcelServiceFilters::create($filters);
    }
    
    
    /**
     * @param string $sorting
     *
     * @return ParcelServiceSorting
     */
    public function createSorting(string $sorting): ParcelServiceSorting
    {
        return ParcelServiceSorting::create($sorting);
    }
}