<?php
/* --------------------------------------------------------------
   ChangedParcelServiceIsDefaultState.php 2020-08-28
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\ParcelService\Model\Events;

use Gambio\Admin\Modules\ParcelService\Model\ValueObjects\ParcelServiceId;

/**
 * Class SetParcelServiceAsDefault
 *
 * @package Gambio\Admin\Modules\ParcelService\Model\Events
 * @codeCoverageIgnore
 */
class SetParcelServiceAsDefault
{
    /**
     * @var ParcelServiceId
     */
    private $id;
    
    
    /**
     * SetParcelServiceAsDefault constructor.
     *
     * @param ParcelServiceId $id
     */
    private function __construct(ParcelServiceId $id)
    {
        $this->id = $id;
    }
    
    
    /**
     * @param ParcelServiceId $id
     *
     * @return SetParcelServiceAsDefault
     */
    public static function create(ParcelServiceId $id): SetParcelServiceAsDefault
    {
        return new self($id);
    }
    
    
    /**
     * @return int
     */
    public function parcelServiceId(): int
    {
        $this->id->value();
    }
}