<?php
/* --------------------------------------------------------------
   UpdatedParcelServiceDescriptions.php 2020-08-28
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\ParcelService\Model\Events;

use Gambio\Admin\Modules\ParcelService\Model\Collections\ParcelServiceDescriptions;
use Gambio\Admin\Modules\ParcelService\Model\ValueObjects\ParcelServiceId;

/**
 * Class UpdatedParcelServiceDescription
 *
 * @package Gambio\Admin\Modules\ParcelService\Model\Events
 * @codeCoverageIgnore
 */
class UpdatedParcelServiceDescriptions
{
    /**
     * @var ParcelServiceId
     */
    private $id;
    
    /**
     * @var ParcelServiceDescriptions
     */
    private $descriptions;
    
    
    /**
     * UpdatedParcelServiceDescriptions constructor.
     *
     * @param ParcelServiceId           $id
     * @param ParcelServiceDescriptions $description
     */
    private function __construct(ParcelServiceId $id, ParcelServiceDescriptions $description)
    {
        $this->id           = $id;
        $this->descriptions = $description;
    }
    
    
    /**
     * @param ParcelServiceId           $id
     * @param ParcelServiceDescriptions $description
     *
     * @return UpdatedParcelServiceDescriptions
     */
    public static function create(
        ParcelServiceId $id,
        ParcelServiceDescriptions $description
    ): UpdatedParcelServiceDescriptions {
        return new self($id, $description);
    }
    
    
    /**
     * @return int
     */
    public function parcelServiceId(): int
    {
        $this->id->value();
    }
    
    
    /**
     * @return ParcelServiceDescriptions
     */
    public function descriptions(): ParcelServiceDescriptions
    {
        $this->descriptions;
    }
}