<?php
/* --------------------------------------------------------------
   ChangedParcelServiceName.php 2020-08-28
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\ParcelService\Model\Events;

use Gambio\Admin\Modules\ParcelService\Model\ValueObjects\ParcelServiceId;

/**
 * Class UpdatedParcelServiceName
 *
 * @package Gambio\Admin\Modules\ParcelService\Model\Events
 * @codeCoverageIgnore
 */
class UpdatedParcelServiceName
{
    /**
     * @var ParcelServiceId
     */
    private $id;
    
    /**
     * @var string
     */
    private $newName;
    
    
    /**
     * UpdatedParcelServiceName constructor.
     *
     * @param ParcelServiceId $id
     * @param string          $newName
     */
    private function __construct(ParcelServiceId $id, string $newName)
    {
        $this->id      = $id;
        $this->newName = $newName;
    }
    
    
    /**
     * @param ParcelServiceId $id
     * @param string          $newName
     *
     * @return UpdatedParcelServiceName
     */
    public static function create(ParcelServiceId $id, string $newName): UpdatedParcelServiceName
    {
        return new self($id, $newName);
    }
    
    
    /**
     * @return int
     */
    public function parcelServiceId(): int
    {
        $this->id->value();
    }
    
    
    /**
     * @return string
     */
    public function newName(): string
    {
        $this->newName;
    }
}