<?php
/* --------------------------------------------------------------
   ParcelServiceFilterService.php 2020-08-28
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\ParcelService\Services;

use Gambio\Admin\Modules\ParcelService\Model\Collections\ParcelServices;

/**
 * Interface ParcelServiceFilterService
 *
 * @package Gambio\Admin\Modules\ParcelService\Services
 */
interface ParcelServiceFilterService
{
    /**
     * @param array  $filters
     * @param string $sorting
     * @param int    $limit
     * @param int    $offset
     *
     * @return ParcelServices
     */
    public function filterParcelServices(
        array $filters,
        string $sorting,
        int $limit = 25,
        int $offset = 0
    ): ParcelServices;
    
    
    /**
     * @param array $filters
     *
     * @return int
     */
    public function getParcelServicesTotalCount(array $filters): int;
}