<?php
/* --------------------------------------------------------------
   ParcelServiceReadService.php 2020-08-28
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\ParcelService\Services;

use Gambio\Admin\Modules\ParcelService\Model\Collections\ParcelServices;
use Gambio\Admin\Modules\ParcelService\Model\Exceptions\ParcelServiceNotFoundException;
use Gambio\Admin\Modules\ParcelService\Model\ParcelService;

/**
 * Interface ParcelServiceReadService
 *
 * @package Gambio\Admin\Modules\ParcelService\Services
 */
interface ParcelServiceReadService
{
    /**
     * @return ParcelServices
     */
    public function getParcelServices(): ParcelServices;
    
    
    /**
     * @param int $id
     *
     * @return ParcelService
     *
     * @throws ParcelServiceNotFoundException
     */
    public function getParcelServiceById(int $id): ParcelService;
}