<?php

/* --------------------------------------------------------------
 routes.php 2020-08-12
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

use Gambio\Admin\Modules\RedirectRules\RedirectRulesAdminController;
use Slim\App;

return static function (App $app) {
    $app->get('/redirect-rules', RedirectRulesAdminController::class . ':showOverview');
    $app->get('/redirect-rules/get-rules', RedirectRulesAdminController::class . ':getRules');
    $app->post('/redirect-rules/add-rule', RedirectRulesAdminController::class . ':addRule');
    $app->post('/redirect-rules/delete-rule', RedirectRulesAdminController::class . ':deleteRule');
    $app->post('/redirect-rules/enable-rule', RedirectRulesAdminController::class . ':enableRule');
    $app->post('/redirect-rules/disable-rule', RedirectRulesAdminController::class . ':disableRule');
    $app->post('/redirect-rules/update-rule', RedirectRulesAdminController::class . ':updateRule');
    $app->get('/redirect-rules/get-configuration', RedirectRulesAdminController::class . ':getConfig');
    $app->post('/redirect-rules/save-configuration', RedirectRulesAdminController::class . ':setConfig');
};
