<?php
/*--------------------------------------------------------------
   TimespanCollection.php 2020-08-14
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Collections;

use Gambio\Admin\Modules\Statistics\Entities\SummarizableTimespan;

/**
 * Class TimespanCollection
 * @package Gambio\Admin\Modules\Statistics\Collections
 */
class SummarizableTimespanCollection extends AbstractCollection
{
    
    /**
     * @inheritDoc
     */
    protected function isValid($value): bool
    {
        return $value instanceof SummarizableTimespan;
    }
    
    
    /**
     * @inheritDoc
     */
    public function current(): SummarizableTimespan
    {
        return $this->currentValue();
    }
}