<?php
/*------------------------------------------------------------------------------
 SummarizedDataCollection.php 2020-08-17
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Collections;

use Gambio\Admin\Modules\Dashboard\StatisticService;
use Gambio\Admin\Modules\Statistics\ValueObjects\SummarizedData;

/**
 * Class SummarizedDataCollection
 * @package Gambio\Admin\Modules\Statistics\Collections
 */
class SummarizedDataCollection extends AbstractCollection
{
    /**
     * @return SummarizedData
     */
    public function current(): SummarizedData
    {
        return $this->values[$this->position];
    }
    
    
    /**
     * @inheritDoc
     */
    protected function isValid($value): bool
    {
        return $value instanceof SummarizedData;
    }
    
    
    /**
     * @inheritDoc
     */
    public function jsonSerialize()
    {
        $result = [];
        /** @var SummarizedData $summarizedData */
        foreach ($this->values as $summarizedData) {
            $result[$summarizedData->name()->value()]  = $summarizedData;
        }
        return $result;
    }
}