<?php
/*------------------------------------------------------------------------------
 SummaryTotalCollection.php 2020-08-14
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Collections;

use Gambio\Admin\Modules\Statistics\ValueObjects\SummaryTotal;

/**
 * Class SummaryTotalCollection
 * @package Gambio\Admin\Modules\Statistics\Collections
 */
class SummaryTotalCollection extends AbstractCollection
{
    /**
     * @return SummaryTotal
     */
    public function current(): SummaryTotal
    {
        return $this->values[$this->position];
    }
    
    
    /**
     * @param $value
     *
     * @return bool
     */
    protected function isValid($value): bool
    {
        return $value instanceof SummaryTotal;
    }
}