<?php
/*--------------------------------------------------------------
   StatisticValue.php 2020-08-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Entities;

use Gambio\Admin\Modules\Statistics\ValueObjects\DateString;
use JsonSerializable;

/**
 * Class StatisticValue
 * @package Gambio\Admin\Modules\Statistics\Entities
 */
class StatisticValue
{
    /**
     * @var DateString
     */
    private $date;
    
    /**
     * @var JsonSerializable
     */
    private $value;
    
    
    /**
     * StatisticValue constructor.
     *
     * @param DateString $date
     * @param float      $value
     */
    public function __construct(DateString $date, float $value)
    {
        $this->date = $date;
        $this->value = $value;
    }
    
    
    /**
     * @return DateString
     */
    public function date(): DateString
    {
        return $this->date;
    }
    
    
    /**
     * @return float
     */
    public function value() : float
    {
        return $this->value;
    }
}