<?php
/* --------------------------------------------------------------
  NoValidUserPreferredCategoryException.php 2021-06-09
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Exceptions;

use Exception;

/**
 * Class NoValidUserPreferredCategoryException
 * @package Gambio\Admin\Modules\Statistics\Exception
 */
class NoValidUserPreferredCategoryException extends Exception
{
    /**
     * @param string $category
     *
     * @return NoValidUserPreferredCategoryException
     */
    public static function create(string $category): NoValidUserPreferredCategoryException {
        return new self("${category} is not a valid category");
    }
}