<?php
/* --------------------------------------------------------------
 NoValidUserPreferredPeriodException.php 2020-09-29
 Gambio GmbH
 http://www.gambio.de

 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Exceptions;

use Exception;

/**
 * Class NoValidUserPreferredPeriodException
 * @package Gambio\Admin\Modules\Statistics\Exception
 */
class NoValidUserPreferredPeriodException extends Exception
{
    /**
     * @param string $period
     *
     * @return NoValidUserPreferredPeriodException
     */
    public static function create(string $period): NoValidUserPreferredPeriodException {
        return new self("${period} is not a valid period");
    }
}