<?php
/*--------------------------------------------------------------
   CouldNotCreateTimespanException.php 2020-08-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Factories\Exceptions;

use Throwable;

/**
 * Class CouldNotCreateTimespanException
 * @package Gambio\Admin\Modules\Statistics\Factories\Exceptions
 */
class CouldNotCreateTimespanException extends \InvalidArgumentException
{
    /**
     * @param string         $value
     * @param array          $supportedTypes
     * @param Throwable|null $previous
     *
     * @return static
     */
    final public static function invalidDatetimeString(
        string $value,
        array $supportedTypes,
        Throwable $previous = null
    ): self {
        
        $supportedTypes = array_map(static function (string $type) {
            return '"' . $type . '"';
        },
            $supportedTypes);
        
        $lastType = array_pop($supportedTypes);
        $message  = 'Timespan could not be created with the value "' . $value . '". ';
        $message  .= 'Only ' . implode(', ', $supportedTypes) . ' and ' . $lastType . ' are supported';
        
        return new static($message, 1, $previous);
    }
}