<?php
/*------------------------------------------------------------------------------
 TimespanFactory.php 2020-08-14
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Factories;

use Exception;
use Gambio\Admin\Modules\Statistics\Collections\SummarizableTimespanCollection;
use Gambio\Admin\Modules\Statistics\Entities\SummarizableTimespan;
use Gambio\Admin\Modules\Statistics\Entities\Timespan;

interface TimespanFactory
{
    /**
     * @return SummarizableTimespanCollection
     * @throws Exceptions\InvalidDateTimespanException
     */
    public function createAll(): SummarizableTimespanCollection;
    
    
    /**
     * @param string $timespanName
     *
     * @return SummarizableTimespan
     * @throws Exceptions\InvalidDateTimespanException
     * @throws Exception
     */
    public function createFromString(string $timespanName): SummarizableTimespan;
    
    
    /**
     * @return Timespan
     * @throws Exceptions\InvalidDateTimespanException
     */
    public function createForTheWholePeriod(): Timespan;
    
}