<?php
/*--------------------------------------------------------------
   ConversionRateDataProvider.php 2020-08-14
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Repositories\Conversion;

use Gambio\Admin\Modules\Statistics\Entities\DataProviderResult;
use Gambio\Admin\Modules\Statistics\Entities\Timespan;
use Gambio\Admin\Modules\Statistics\Repositories\Conversion\Factories\ConversionDataProviderResultFactory;
use Gambio\Admin\Modules\Statistics\Repositories\Conversion\Reader\ConversionReader;
use Gambio\Admin\Modules\Statistics\Repositories\StatisticsDataProvider;

/**
 * Class ConversionRateDataProvider
 * @package Gambio\Admin\Modules\Statistics\Repositories
 */
class ConversionRateDataProvider implements StatisticsDataProvider
{
    /**
     * @var ConversionReader
     */
    private $reader;
    
    /**
     * @var ConversionDataProviderResultFactory
     */
    private $factory;
    
    
    /**
     * ConversionRateDataProvider constructor.
     *
     * @param ConversionReader                    $reader
     * @param ConversionDataProviderResultFactory $factory
     */
    public function __construct(ConversionReader $reader, ConversionDataProviderResultFactory $factory)
    {
        $this->reader  = $reader;
        $this->factory = $factory;
    }
    
    
    /**
     * @inheritDoc
     */
    public function fromTimespan(Timespan $timespan): DataProviderResult
    {
        return $this->factory->create($this->reader->fromTimespan($timespan));
    }
}