<?php
/*--------------------------------------------------------------
   ConversionDataProviderResult.php 2021-06-07
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2021 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Repositories\Conversion\Entities;

use Gambio\Admin\Modules\Statistics\Collections\StatisticValueCollection;
use Gambio\Admin\Modules\Statistics\Entities\DataProviderResult;
use Gambio\Admin\Modules\Statistics\ValueObjects\Name;
use Gambio\Admin\Modules\Statistics\ValueObjects\Title;
use Gambio\Admin\Modules\Statistics\ValueObjects\Unit;
use Gambio\Admin\Modules\Statistics\ValueObjects\Style;
use Gambio\Admin\Modules\Statistics\ValueObjects\MinimumFractionDigits;

/**
 * Class ConversionDataProviderResult
 * @package Gambio\Admin\Modules\Statistics\Repositories\Conversion\Entities
 */
class ConversionDataProviderResult extends DataProviderResult
{
    /**
     * ConversionDataProviderResult constructor.
     *
     * @param Title                    $title
     * @param Unit                     $unit
     * @param Style                    $style
     * @param MinimumFractionDigits    $minimumFractionDigits
     * @param StatisticValueCollection $statisticValues
     */
    public function __construct(Title $title, Unit $unit, Style $style, MinimumFractionDigits $minimumFractionDigits, StatisticValueCollection $statisticValues)
    {
        parent::__construct(new Name('conversions'), $title, $unit, $style, $minimumFractionDigits, $statisticValues);
    }
}