<?php
/* --------------------------------------------------------------
 VisitorsReader.php 2020-08-14
 Gambio GmbH
 http://www.gambio.de

 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Repositories\Visitors\Readers;

use Gambio\Admin\Modules\Statistics\Collections\StatisticValueCollection;
use Gambio\Admin\Modules\Statistics\Entities\Timespan;

/**
 * Interface VisitorsReader
 * @package Gambio\Admin\Modules\Statistics\Repositories\Visitors\Readers
 */
interface VisitorsReader
{
    
    /**
     * @param Timespan $timespan
     *
     * @return StatisticValueCollection
     */
    public function fromTimespan(Timespan $timespan): StatisticValueCollection;
}