<?php
/*--------------------------------------------------------------
   VisitorsDataProvider.php 2020-08-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Repositories\Visitors;

use Gambio\Admin\Modules\Statistics\Entities\DataProviderResult;
use Gambio\Admin\Modules\Statistics\Entities\Timespan;
use Gambio\Admin\Modules\Statistics\Repositories\StatisticsDataProvider;
use Gambio\Admin\Modules\Statistics\Repositories\Visitors\Factories\VisitorsDataProviderResultFactory;
use Gambio\Admin\Modules\Statistics\Repositories\Visitors\Readers\VisitorsReader;

/**
 * Class VisitorsDataProvider
 * @package Gambio\Admin\Modules\Statistics\Repositories
 */
class VisitorsDataProvider implements StatisticsDataProvider
{
    /**
     * @var VisitorsReader
     */
    private $reader;
    
    /**
     * @var VisitorsDataProviderResultFactory
     */
    private $factory;
    
    
    /**
     * VisitorsDataProvider constructor.
     *
     * @param VisitorsReader                    $reader
     * @param VisitorsDataProviderResultFactory $factory
     */
    public function __construct(VisitorsReader $reader, VisitorsDataProviderResultFactory $factory)
    {
        $this->reader  = $reader;
        $this->factory = $factory;
    }
    
    
    /**
     * @inheritDoc
     */
    public function fromTimespan(Timespan $timespan): DataProviderResult
    {
        return $this->factory->create($this->reader->fromTimespan($timespan));
    }
}