<?php
/*--------------------------------------------------------------
  StatisticsServiceInterface.php 2021-06-07
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics;

use Gambio\Admin\Modules\Statistics\ValueObjects\StatisticsResult;
use Gambio\Admin\Modules\Statistics\ValueObjects\UserPreferredCategory;
use Gambio\Admin\Modules\Statistics\ValueObjects\UserPreferredPeriod;

/**
 * Interface StatisticsServiceInterface
 * @package Gambio\Admin\Modules\Statistics
 */
interface StatisticsServiceInterface
{
    /**
     * @return StatisticsResult
     */
    public function statistics(): StatisticsResult;
    
    
    /**
     * @param string $period
     */
    public function updateUserPreferredPeriod(string $period): void;
    
    
    /**
     * @return UserPreferredPeriod|null
     */
    public function getUserPreferredPeriod(): ?UserPreferredPeriod;
    
    
    /**
     * @param string $category
     */
    public function updateUserPreferredCategory(string $category): void;
    
    
    /**
     * @return UserPreferredCategory|null
     */
    public function getUserPreferredCategory(): ?UserPreferredCategory;
}