<?php
/* --------------------------------------------------------------
  StatisticsStorage.php 2021-06-09
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  --------------------------------------------------------------
 */

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Storage;

use Gambio\Admin\Modules\Statistics\Exceptions\NoValidUserPreferredCategoryException;
use Gambio\Admin\Modules\Statistics\Exceptions\NoValidUserPreferredPeriodException;
use Gambio\Admin\Modules\Statistics\ValueObjects\UserPreferredCategory;
use Gambio\Admin\Modules\Statistics\ValueObjects\UserPreferredPeriod;

/**
 * Interface StatisticsStorage
 * @package Gambio\Admin\Modules\Statistics\Storage
 */
interface StatisticsStorage
{
    /**
     * @param UserPreferredPeriod $period
     */
    public function setPreferredPeriod(UserPreferredPeriod $period): void;
    
    
    /**
     * @return UserPreferredPeriod
     * @throws NoValidUserPreferredPeriodException
     */
    public function getPreferredPeriod(): UserPreferredPeriod;
    
    
    /**
     * @param UserPreferredCategory $category
     */
    public function setPreferredCategory(UserPreferredCategory $category): void;
    
    
    /**
     * @return UserPreferredCategory
     * @throws NoValidUserPreferredCategoryException
     */
    public function getPreferredCategory(): UserPreferredCategory;
}