<?php
/*------------------------------------------------------------------------------
 StatisticSummarizerService.php 2020-08-14
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\Summarizer;

use Exception;
use Gambio\Admin\Modules\Statistics\Entities\DataProviderResult;
use Gambio\Admin\Modules\Statistics\Entities\Timespan;
use Gambio\Admin\Modules\Statistics\ValueObjects\SummarizedData;

interface StatisticSummarizer
{
    /**
     * @param Timespan           $timespan
     * @param DataProviderResult ...$values
     *
     * @return SummarizedData
     * @throws Exception
     */
    public function summarize(Timespan $timespan, DataProviderResult ...$values): SummarizedData;

}