<?php
/*--------------------------------------------------------------
   DateString.php 2020-08-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

use DateTime;

/**
 * Class DateString
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class DateString
{
    /**
     * @var string
     */
    private $date;
    
    /**
     * @var DateTime
     */
    private $dateTime;
    
    
    /**
     * DateString constructor.
     *
     * @param string $date
     *
     * @throws \Exception
     */
    public function __construct(string $date)
    {
        $this->date     = $date;
        $this->dateTime = new DateTime($date);
    }
    
    
    /**
     * @return string
     */
    public function value(): string
    {
        return $this->date;
    }
    
    
    /**
     * @return DateTime
     */
    public function asDateTime(): DateTime
    {
        return $this->dateTime;
    }
}