<?php
/*--------------------------------------------------------------
   Name.php 2020-08-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

use JsonSerializable;

/**
 * Class Name
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class Name implements JsonSerializable
{
    /**
     * @var string
     */
    private $name;
    
    
    /**
     * Name constructor.
     *
     * @param string $name
     */
    public function __construct(string $name)
    {
        $this->name = $name;
    }
    
    
    /**
     * @return string
     */
    public function value(): string
    {
        return $this->name;
    }
    
    
    /**
     * @inheritDoc
     */
    public function jsonSerialize()
    {
        return $this->value();
    }
}