<?php
/*--------------------------------------------------------------
  Style.php 2021-06-07
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

use JsonSerializable;

/**
 * Class Style
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class Style implements JsonSerializable
{
    /**
     * @var string
     */
    private $style;
    
    
    /**
     * Style constructor.
     *
     * @param string $style
     */
    public function __construct(string $style)
    {
        $this->style = $style;
    }
    
    
    /**
     * @return string
     */
    public function value(): string
    {
        return $this->style;
    }
    
    
    /**
     * @inheritDoc
     */
    public function jsonSerialize()
    {
        return $this->value();
    }
}