<?php
/*------------------------------------------------------------------------------
 SummaryPartial.php 2020-08-14
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

/**
 * Class SummaryPartial
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class SummaryPartial
{
    /**
     * @var SummaryPartialLabel
     */
    private $label;
    /**
     * @var SummaryPartialValue[]
     */
    private $values;
    
    
    /**
     * @return SummaryPartialLabel
     */
    public function label(): SummaryPartialLabel
    {
        return $this->label;
    }
    
    
    /**
     * @return SummaryPartialValue[]
     */
    public function values(): array
    {
        return $this->values;
    }
    
    
    public function __construct(SummaryPartialLabel $label, SummaryPartialValue ...$values)
    {
        $this->label  = $label;
        $this->values = $values;
    }
}