<?php
/*------------------------------------------------------------------------------
  SummaryPartialValue.php 2021-06-07
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

/**
 * Class SummaryPartialValue
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class SummaryPartialValue
{
    
    /**
     * @var string
     */
    private $title;
    
    
    /**
     * @var float
     */
    private $value;
    
    
    /**
     * SummaryPartialValue constructor.
     *
     * @param string $title
     * @param        $value
     */
    public function __construct(string $title, $value)
    {
        
        $this->title = $title;
        $this->value = (float)(string)$value;
    }
    
    
    /**
     * @return string
     */
    public function title(): string
    {
        return $this->title;
    }
    
    
    /**
     * @return float
     */
    public function value(): float
    {
        return $this->value;
    }
    
}