<?php
/*------------------------------------------------------------------------------
  SummaryTotal.php 2020-09-09
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2020 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  -----------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

/**
 * Class SummaryTotal
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class SummaryTotal
{
    /**
     * @var string
     */
    private $name;
    /**
     * @var float
     */
    private $total;
    /**
     * @var float
     */
    private $change;
    
    
    /**
     * SummaryTotal constructor.
     *
     * @param string $name
     * @param float    $total
     * @param float    $change
     */
    public function __construct(string $name, $total, $change)
    {
        $this->name   = $name;
        $this->total  = (float)(string)$total;
        $this->change = (float)(string)$change;
    }
    
    
    /**
     * @return string
     */
    public function name(): string
    {
        return $this->name;
    }
    
    
    /**
     * @return float
     */
    public function total(): float
    {
        return $this->total;
    }
    
    
    /**
     * @return float
     */
    public function change(): float
    {
        return $this->change;
    }
    
    
}