<?php
/*--------------------------------------------------------------
  Unit.php 2021-06-07
  Gambio GmbH
  http://www.gambio.de
  Copyright (c) 2021 Gambio GmbH
  Released under the GNU General Public License (Version 2)
  [http://www.gnu.org/licenses/gpl-2.0.html]
  -------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Statistics\ValueObjects;

use JsonSerializable;

/**
 * Unit Name
 * @package Gambio\Admin\Modules\Statistics\ValueObjects
 */
class Unit implements JsonSerializable
{
    /**
     * @var string
     */
    private $unit;
    
    
    /**
     * Unit constructor.
     *
     * @param string $unit
     */
    public function __construct(string $unit)
    {
        $this->unit = $unit;
    }
    
    
    /**
     * @return string
     */
    public function value(): string
    {
        return $this->unit;
    }
    
    
    /**
     * @inheritDoc
     */
    public function jsonSerialize()
    {
        return $this->value();
    }
}