<?php
/* --------------------------------------------------------------
   CreatedTrackingCode.php 2020-09-01
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\TrackingCode\Model\Events;

use Gambio\Admin\Modules\TrackingCode\Model\ValueObjects\TrackingCodeId;

/**
 * Class CreatedTrackingCode
 *
 * @package Gambio\Admin\Modules\TrackingCode\Model\Events
 * @codeCoverageIgnore
 */
class CreatedTrackingCode
{
    /**
     * @var TrackingCodeId
     */
    private $id;
    
    
    /**
     * DeletedTrackingCode constructor.
     *
     * @param TrackingCodeId $id
     */
    private function __construct(TrackingCodeId $id)
    {
        $this->id = $id;
    }
    
    
    /**
     * @param TrackingCodeId $id
     *
     * @return CreatedTrackingCode
     */
    public static function create(TrackingCodeId $id): CreatedTrackingCode
    {
        return new self($id);
    }
    
    
    /**
     * @return int
     */
    public function trackingCodeId(): int
    {
        $this->id->value();
    }
}