<?php
/* --------------------------------------------------------------
   TrackingCodeFilterService.php 2020-09-01
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\TrackingCode\Services;

use Gambio\Admin\Modules\TrackingCode\Model\Collections\TrackingCodes;

/**
 * Interface TrackingCodeFilterService
 *
 * @package Gambio\Admin\Modules\TrackingCode\Services
 */
interface TrackingCodeFilterService
{
    /**
     * @param array  $filters
     * @param string $sorting
     * @param int    $limit
     * @param int    $offset
     *
     * @return TrackingCodes
     */
    public function filterTrackingCodes(
        array $filters,
        string $sorting,
        int $limit = 25,
        int $offset = 0
    ): TrackingCodes;
    
    
    /**
     * @param array $filters
     *
     * @return int
     */
    public function getTrackingCodesTotalCount(array $filters): int;
}