<?php
/* --------------------------------------------------------------
   TrackingCodeReadService.php 2020-09-01
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\TrackingCode\Services;

use Gambio\Admin\Modules\TrackingCode\Model\Collections\TrackingCodes;
use Gambio\Admin\Modules\TrackingCode\Model\Exceptions\TrackingCodeNotFoundException;
use Gambio\Admin\Modules\TrackingCode\Model\TrackingCode;

/**
 * Interface TrackingCodeReadService
 *
 * @package Gambio\Admin\Modules\TrackingCode\Services
 */
interface TrackingCodeReadService
{
    /**
     * @return TrackingCodes
     */
    public function getTrackingCodes(): TrackingCodes;
    
    
    /**
     * @param int $id
     *
     * @return TrackingCode
     *
     * @throws TrackingCodeNotFoundException
     */
    public function getTrackingCodeById(int $id): TrackingCode;
    
    
    /**
     * @param int $orderId
     *
     * @return TrackingCodes
     */
    public function getTrackingCodesByOrderId(int $orderId): TrackingCodes;
}