<?php
/* --------------------------------------------------------------
   DeletedWithdrawal.php 2020-08-24
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Withdrawal\Model\Events;

use Gambio\Admin\Modules\Withdrawal\Model\ValueObjects\WithdrawalId;

/**
 * Class DeletedWithdrawal
 *
 * @package Gambio\Admin\Modules\Withdrawal\Model\Events
 * @codeCoverageIgnore
 */
class DeletedWithdrawal
{
    /**
     * @var WithdrawalId
     */
    private $id;
    
    
    /**
     * DeletedWithdrawal constructor.
     *
     * @param WithdrawalId $id
     */
    private function __construct(WithdrawalId $id)
    {
        $this->id = $id;
    }
    
    
    /**
     * @param WithdrawalId $id
     *
     * @return DeletedWithdrawal
     */
    public static function create(WithdrawalId $id): DeletedWithdrawal
    {
        return new self($id);
    }
    
    
    /**
     * @return int
     */
    public function withdrawalId(): int
    {
        $this->id->value();
    }
}