<?php
/* --------------------------------------------------------------
   WithdrawalFilterService.php 2020-08-26
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\Modules\Withdrawal\Services;

use Gambio\Admin\Modules\Withdrawal\Model\Collections\Withdrawals;

/**
 * Interface WithdrawalFilterService
 *
 * @package Gambio\Admin\Modules\Withdrawal\Services
 */
interface WithdrawalFilterService
{
    /**
     * @param array  $filters
     * @param string $sorting
     * @param int    $limit
     * @param int    $offset
     *
     * @return Withdrawals
     */
    public function filterWithdrawals(array $filters, string $sorting, int $limit = 25, int $offset = 0): Withdrawals;
    
    
    /**
     * @param array $filters
     *
     * @return int
     */
    public function getWithdrawalsTotalCount(array $filters): int;
}