/* --------------------------------------------------------------
 gulp_general_coverage.js 2016-09-23
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2016 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

'use strict';

/**
 * Gulp StyleEdit3 PHPUnit Coverage Task (Unix Systems Only)
 *
 * This task will generate the "StyleEdit3" test folder coverage information by executing the run_tests.sh script with the
 * correct parameters. In addition to that, a testdox-style- file will be generated in the same directory.
 *
 * Output Directory: developers.gambio.de/tests
 *
 * @param {Gulp} gulp Gulp Instance
 * @param {Object} $ Contains the automatically loaded gulp plugins.
 *
 * @return {Function} Returns the gulp task definition.
 */
module.exports = function(gulp, $) {
	const task = $.shell.task([
		'php phpunit.phar --configuration ../tests/StyleEdit3/phpunit.styleedit.xml '
		+ '--coverage-html ../developers.gambio.de/tests/coverage-style-edit3 '
		+ '--testdox-text ../developers.gambio.de/tests/testdox-style-edit3.txt '
		+ 'StyleEdit3/php'
	], {cwd: 'tests'});
	
	task.__description = 'Create coverage documents for the StyleEdit tests.';
	
	return task;
};
