/* --------------------------------------------------------------
 gulp_style_edit_scripts.js 2016-09-23
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2016 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

'use strict';

/**
 * Gulp StyleEdit Scripts Task
 *
 * This task will use the StyleEdit3 browserify handler to bundle the style_edit.js file.
 *
 * @param {Gulp} gulp Gulp Instance
 * @param {Object} $ Contains the automatically loaded gulp plugins.
 *
 * @return {Function} Returns the gulp task definition.
 */
module.exports = function(gulp, $) {
	const bundle = require('../browserify')(gulp, $, false, '../StyleEdit3/javascript/main.js', '../StyleEdit3/assets/javascript/style_edit.js');
	
	function task() {
		return bundle();
	}
	
	task.__description = 'Will only build the StyleEdit JavaScript files.';
	
	return task;
};
