/* --------------------------------------------------------------
 gulp_admin_styles.js 2016-09-23
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2016 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

'use strict';

/**
 * Gulp StyleEdit Styles Task
 *
 * This task will handle the compilation of the StyleEdit SASS.
 *
 * @param {Gulp} gulp Gulp Instance
 * @param {Object} $ Contains the automatically loaded gulp plugins.
 *
 * @return {Function} Returns the gulp task definition.
 */
module.exports = function(gulp, $) {
	const fs = require('fs');
	const path = require('path');
	const notifier = require('node-notifier');
	const ftp = require('../ftp');
	
	function task() {
		return gulp.src('../StyleEdit3/styles/*.scss')
			.pipe($.sass({
				css: '../StyleEdit3/assets/styles',
				sass: '../StyleEdit3/styles',
				style: 'expanded',
				sourcemap: true,
				logging: true,
				importer: require('node-sass-tilde-importer')
			}))
			.pipe(gulp.dest('../StyleEdit3/assets/styles'))
			.pipe(ftp.upload('../StyleEdit3/assets/styles'))
			.pipe($.cleanCss({processImport: false}))
			.pipe($.rename({suffix: '.min'}))
			.pipe(gulp.dest('../StyleEdit3/assets/styles'))
			.pipe(ftp.upload('../StyleEdit3/assets/styles'));
	}
	
	task.__description = 'Will only build the StyleEdit style files.';
	
	return task;
};
