/* --------------------------------------------------------------
 gulp_style_edit_test.js 2018-11-21
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2018 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

'use strict';

/**
 * Gulp StyleEdit Test Task
 *
 * This task will execute all the StyleEdit3 unit tests with PhpUnit and Mocha. PhpUnit and Mocha need to be installed
 * globally otherwise this task will not work.
 *
 * @param {Gulp} gulp Gulp Instance
 * @param {Object} $ Contains the automatically loaded gulp plugins.
 *
 * @return {Function} Returns the gulp task definition.
 */
module.exports = function(gulp, $) {
	const task = $.shell.task([
		'php composer_components/bin/phpunit -c tests/StyleEdit3/phpunit.styleedit.xml tests/StyleEdit3/php',
		'mocha --require babel-register --recursive tests/StyleEdit3/javascript'
	], {cwd: '.'});
	
	task.__description = 'Execute the PhpUnit and Mocha tests. ';
	
	return task;
};

