/* --------------------------------------------------------------
 gulp_style_edit_watch.js 2016-09-23
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2016 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

'use strict';

/**
 * Gulp General Watch Task
 *
 * This tasks checks for changes in the src/JSEngine directory and performs the required actions.
 *
 * @param {Gulp} gulp Gulp Instance
 * @param {Object} $ Contains the automatically loaded gulp plugins.
 *
 * @return {Function} Returns the gulp task definition.
 */
module.exports = function(gulp, $) {
	const bundle = require('../browserify')(gulp, $, true, '../StyleEdit3/javascript/main.js', '../StyleEdit3/assets/javascript/style_edit.js');
	
	function task() {
		gulp.watch([
				'../StyleEdit3/styles/**/*.scss'
			],
			['style_edit:styles']);
		
		// This bundle execution will enable watchify which makes quick builds whenever a change is detected.
		bundle();
	}
	
	task.__description =
		'Will start the file watchers for the StyleEdit files (prefer the "dev" task for development).';
	
	return task;
};
